#include <QWidget>
#include <QLineEdit>
#include <QPushButton>
#include <QHBoxLayout>
#include <QApplication>
#include <qlabel.h>
#include <qtextedit.h>
#include <QMessageBox>

using namespace std;
size_t myfind(const std::wstring &S, const std::wstring &P) {
    int D[P.size()];
    D[0] = 0;
    for (int i = 1, j = 0; i < P.size(); i++) {
        while (j > 0 && P[i] != P[j]) j = D[j - 1];
        if (P[i] == P[j])j++;
        D[i] = j;
    }// Крок 2
    for (int i = 0, d = 1; d-1 < P.size() && i < S.size(); ) {
        if (S[i] == P[d-1]) {// Крок 3
            d++;
            i++;
            if (d == P.size())
              return i - d+1;
        } else{ // Крок 4
            i = i + d - D[d];
            d=1;
          }
    }
    return string::npos;
}
class SortingApp : public QWidget {
public:
    SortingApp(QWidget *parent = nullptr) : QWidget(parent) {
        setupUI();
    }
private:
    QLineEdit *inputField1;
    QLineEdit *inputField2;
    QTextEdit *outputField;
    QPushButton *testButton;
    void setupUI() {
        QVBoxLayout *mainLayout = new QVBoxLayout(this);

        QLabel *label = new QLabel("Перший текст", this);
        mainLayout->addWidget(label);
        inputField1 = new QLineEdit(this);
        mainLayout->addWidget(inputField1);
        QLabel *label2 = new QLabel("Другий текст", this);
        mainLayout->addWidget(label2);
        inputField2 = new QLineEdit(this);
        mainLayout->addWidget(inputField2);
        
        QPushButton *findButton = new QPushButton("Виконати індивідуальне завдання", this);
        connect(findButton, &QPushButton::clicked, this, &SortingApp::find);
        QHBoxLayout *buttons = new QHBoxLayout();
        buttons->addWidget(findButton);
        mainLayout->addLayout(buttons);

        outputField = new QTextEdit(this);
        outputField->setReadOnly(true);
        mainLayout->addWidget(outputField);

        setLayout(mainLayout);
        setWindowTitle("alko10");
        resize(500, 0);
    }
private slots:
    void find() {
        if (inputField1->text().isEmpty() || inputField2->text().isEmpty()) {
            QMessageBox::warning(this, "Помилка", "Заповніть всі поля");
            return;
        }
#define text1 inputField1->text().toStdWString()
#define text2 inputField2->text().toStdWString()
      //wstring debug=text1;
        wstring word;
        size_t start=0;
        size_t end=text1.size();
        for (int i = text1.size()/2; i > 1; i--)
            if (text1[i-1] == ' ') {start=i;break;}
        for (int j = text1.size()/2+1; j < text1.size(); j++)
            if (text1[j] == ' ') {
                end=j;
                break;
            }
        word = text1.substr(start, end - start);
        for (int i = 0; i < word.size(); i++) {
            if (word[i] == L'а') {
                word[i] = L'о';
            } else if (word[i] == L'і') {
                word[i] = L'е';
            }
        }
        int index = myfind(text2,word);
        if (index != string::npos) {
            outputField->setText("Слово " + QString::fromStdWString(word) + " знайдено в тексті 2 на позиції " + QString::number(index));
        } else {
            outputField->setText("Слово " + QString::fromStdWString(word) + " не знайдено в тексті 2");
        }
    }
};

int main(int argc, char *argv[]) {
    QApplication app(argc, argv);
    SortingApp sortingApp;
    sortingApp.show();
    return app.exec();
}
